/* 	BAN-PLUGIN V2
	WRITTEN BY: Sir Drink a lot
	visit: www.adminmod.de
	
	DESCRIPTION: 	banned player are written to userban.cfg. This cfg can be executed in server.cfg
			It has additional information, who has banned the player and when he was banned.
			
	COMMANDS:	admin_ban <Playername> <bantime> <reason>
			admin_bansearch <Some Data>
			admin_banlist <LineNr>
			admin_bandelete <LineNr>
			
	HISTORY:
	08.06.03:	- admin_ban <wonid> <bantime> <reason>, when player is not online!
			- filesize bug removed.
	21.12.02:	- Bug found by Black Knight. filesize() is not correct.
			- ristrict display to 98 characters to avoid AMX Error 10
	27.10.02:	- new code structure
	
			- admin_bansearch <Playername OR WONID>
			  This feature allows you to search for a player which is banned.
			  The linenumber can be used for unbanning the player.
			  
			- admin_banlist <LineNr>
			  This feature allows you to toggle through your userban.cfg and
			  the linenumber can be used for unbanning the player.
			  
			- admin_bandelete <LineNr>
			  You have to find out the linenumber in userban.cfg first. Use admin_findban
			  or admin_showban 
	14.07.02:	- admin_ban <playername> <bantime> <reason>	
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH] = "V2 07.06.03";

new Adminname[MAX_DATA_LENGTH];
new Admincfg[MAX_TEXT_LENGTH]="addons/adminmod/config/sdal_ban/admins.cfg";
new Userbancfg[MAX_TEXT_LENGTH]="addons/adminmod/config/sdal_ban/userban.cfg";

/*Die Reihenfolge muss bestehen bleiben, da die Befehle in Execute auch so angeordnet sind*/
#define MAX_COMMANDS 	4
#define BANID 		0
#define SEARCH 		1
#define LIST 		2
#define DELETE	 	3

new Execute[MAX_COMMANDS][] = {{"ban"},{"bansearch"},{"banlist"},{"bandelete"}};

public sanction(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_DATA_LENGTH];
	new dummy[6];
	new i;
	new iData;
	new adminwonid;
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	
	get_userWONID(User,adminwonid);
	
	strsplit(Command,"_",dummy,6,Command,MAX_COMMAND_LENGTH);
	
	for(i=0;i<MAX_COMMANDS;i++){
		if(strcmp(Execute[i],Command)==0){
			switch(i){
				case BANID: 	banplayer(User,adminwonid,Data);
				case SEARCH:	filecheck(Data,1,SEARCH);
				case LIST: 	{	
							iData=strtonum(Data);
							if(iData==0){
								iData=1;
							}
							filecheck("",iData,LIST);
						}
				case DELETE:	{
							iData=strtonum(Data); 
							bandelete(User,adminwonid,iData);
						}
			}
			break;
		}
	}
	return PLUGIN_HANDLED;
}

bandelete(User[],adminwonid,iDeleteLine){
	new FileData[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Data1[MAX_DATA_LENGTH];
	new Banid[MAX_DATA_LENGTH];
	new iline;
			
	iline=filesize(Userbancfg);
	
	selfmessage("");
	selfmessage("----------------------- BAN-DELETE IN USERBAN.CFG -------------------------");
	selfmessage("");
	if(iline < iDeleteLine || iDeleteLine <=0 ){
		selfmessage("Zeilennummer existiert nicht!");
	}else{
		readfile(Userbancfg,FileData,iDeleteLine,MAX_DATA_LENGTH);
		if(FileData[0]=='/' || strlen(FileData)==0){
			selfmessage("Zeile ist bereits auskommentiert oder leer und der ban damit aufgehoben/nicht vorhanden!");
		}else{
			strsep(FileData,"//",Banid,MAX_TEXT_LENGTH,Data,MAX_DATA_LENGTH);
			look(adminwonid,User);
			snprintf(Data1,MAX_DATA_LENGTH,"//Deleted by: %s (%i)//%s",Adminname,adminwonid,Data);
			writefile(Userbancfg,Data1,iDeleteLine);
			selfmessage("Zeile wurde auskommentiertt!");
		}
	}
	selfmessage("");
	selfmessage("------------------------------------------------------------------------------");
	return PLUGIN_HANDLED;
}

banplayer(User[],adminwonid,Content[]) {
	
	new Message[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new ST[MAX_DATA_LENGTH];
	new BanTime[MAX_NUMBER_LENGTH];
	new Banid[MAX_TEXT_LENGTH];
	new playerwonid;
	new bantime=0;
	new int;
		
	/*--- Die Dateneingabe des Admins in seine Einzelteile zerlegen.  		---*/
	/*--- Einzelteile werden durch das Leerzeichen erkannt.		  		---*/
	/*--- Reihenfolge muss lauten: Eindeutiger Teil des Playernamens,		---*/
	/*--- Dauer des Bans und Grund des Bans.(Grund ist nicht zwingend notwendig).	---*/
	strbreak(Content,Player,Message,MAX_TEXT_LENGTH);
	strbreak(Message,BanTime,Message,MAX_TEXT_LENGTH);
	
	int=strtonum(Player);
	
	if(int==0){
		/*--- Spielernamen berprfen, Admin-Check ---*/
		if (check_user(Player)==1) {
			get_username(Player,TargetName,MAX_NAME_LENGTH);
			if(check_immunity(Player)==1) {
				snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't ban '%s', you silly bear.", TargetName);
				selfmessage(Text);
				return PLUGIN_HANDLED;
			}
			/*--- Daten fr das Textfile herausfinden und reinschreiben ---*/
			get_userWONID(Player,playerwonid);
		}else{
			selfmessage("");
			selfmessage("Spieler wurde nicht eindeutig identifiziert.");
			selfmessage("");
			return PLUGIN_HANDLED;
		}
	}else{
		strcpy(TargetName,"Name NOT available!",MAX_NAME_LENGTH);
		playerwonid=int;
	}
	
	look(adminwonid,User); /*korrekten Admin-Namen raussuchen*/
	servertime(ST, MAX_DATA_LENGTH, "%d.%m.%y %H:%M:%S");
	/*--- Dauer des Bans checken ---*/
	bantime=strtonum(BanTime);
	if(bantime == 0){
		snprintf(Banid,MAX_TEXT_LENGTH,"banid 0.0 %i //",playerwonid);
	}else{
		snprintf(Banid,MAX_TEXT_LENGTH,"//Zeitban//");
	}

	/*--- ALT+Numpad 169 ergibt . Feines Trennungszeichen ---*/
	snprintf(Text,MAX_TEXT_LENGTH,"%s%s%i%s%s%i%s%i",Banid,TargetName,playerwonid,ST,Adminname,adminwonid,Message,bantime);
	writefile(Userbancfg,Text,-1);
	/*um AMX 10 Error zu vermeiden*/
	strcpy(Text,Text,98);
	/*--- Message fr den Admin, der den Ban auspricht ---*/
	selfmessage("");
	selfmessage("Player banned:");
	selfmessage(Text);
	selfmessage("");

	/*--- Player bannen und Zeit und Grund anzeigen---*/
	if(int==0){
		snprintf(Text,MAX_TEXT_LENGTH,"Du wurdest fuer %i Minuten gebannt! (0=permanent)",bantime);
		messageex(TargetName,Text,print_console);
		snprintf(Text,MAX_TEXT_LENGTH,"Grund:%s",Message);
		messageex(TargetName,Text,print_console);
	}
	ban(Player,bantime,bBanByID);

	return PLUGIN_HANDLED;
}
filecheck(Data[],iLine,Mode){
	new FileData[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new DataX[MAX_DATA_LENGTH];
	new Banid[MAX_DATA_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new PlayerWONID[MAX_NUMBER_LENGTH];
	new AdminName[MAX_NAME_LENGTH];
	new AdminWONID[MAX_NUMBER_LENGTH];
	new ST[MAX_DATA_LENGTH];
	new Message[MAX_TEXT_LENGTH];
	new Bantime[MAX_NUMBER_LENGTH];
	new fileline;
	new i;
	new x;
	new y;
		
	if (!fileexists(Userbancfg)){
		selfmessage("------ PLUGIN_SDAL_BAN ------");
		selfmessage("Fehler:");
		selfmessage("Kann userban.cfg nicht finden");
		selfmessage("");
		return PLUGIN_HANDLED;
	}
	fileline=filesize(Userbancfg);
	
	snprintf(Text,MAX_TEXT_LENGTH,"Zeilen in der userban.cfg: %i -- Anzeige: Max. 98 Zeichen pro Zeile",fileline);
	
	if(Mode==1){
		selfmessage("");
		selfmessage("-------------------- BAN-SEARCH IN USERBAN.CFG ---------------------");
		selfmessage(Text);
		selfmessage("-------------------------------------------------------------------------");
	}else{
		selfmessage("");
		selfmessage("----------------------- BAN-LIST IN USERBAN.CFG -------------------------");
		selfmessage(Text);
		selfmessage("--------------------");
		if(fileline < iLine || iLine < 0 || fileline==0){
			selfmessage("");
			selfmessage("Zeilennummer existiert nicht oder keine Daten vorhanden!");
			selfmessage("");
			selfmessage("-------------------------------------------------------------------------------------");
			return PLUGIN_HANDLED;
		}
	}
	for(i=iLine;i<=fileline;i++){
		if(Mode==1){
			if(y==5){
				selfmessage("");
				selfmessage("Maximales Suchergebniss von 5 Zeilen erreicht!");
				break;
			}
		}else{
			if(i>=iLine+5){
				break;	
			}
		}	
		readfile(Userbancfg,FileData,i,MAX_TEXT_LENGTH);
		if(strlen(FileData)!=0){
			strsep(FileData,"//",Banid,MAX_TEXT_LENGTH,DataX,MAX_DATA_LENGTH);
			strsplit(DataX,"",TargetName,MAX_NAME_LENGTH,PlayerWONID,MAX_NUMBER_LENGTH,
				ST,MAX_DATA_LENGTH,AdminName,MAX_NAME_LENGTH,AdminWONID,MAX_NUMBER_LENGTH,
				Message,MAX_TEXT_LENGTH,Bantime,MAX_NUMBER_LENGTH);
			if(Mode==1){
				if(strcasestr(DataX,Data)>0){
					x=1;
					y++;
				}
			}else{
				x=1;
				
			}
			if(x==1){
				strinit(FileData);
				snprintf(Text,MAX_TEXT_LENGTH,"--- Line:%i ---",i);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"BANID:^t^t^t^t^t^t^t^t^t^t %s",Banid);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"Spielername:^t %s (%s)",TargetName,PlayerWONID);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"Ban-Uhrzeit:^t%s",ST);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"Ban von Admin:^t%s (%s)",AdminName,AdminWONID);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"Ban-Message:^t%s",Message);
				strcpy(Text,Text,98);
				selfmessage(Text);
				snprintf(Text,MAX_TEXT_LENGTH,"Bantime:^t^t^t^t^t%s",Bantime);
				strcpy(Text,Text,98);
				selfmessage(Text);
				x=0;
				strinit(Banid);
				strinit(TargetName);
				strinit(PlayerWONID);
				strinit(ST);
				strinit(AdminName);
				strinit(AdminWONID);
				strinit(Message);
				strinit(Bantime);
			}
		}
	}
	if(Mode==1){
		if(y==0){
			selfmessage("Keine Daten gefunden");
			selfmessage("");
		}
	}
	selfmessage( "-------------------------------------------------------------------------------------");
	if(Mode==1){
		snprintf(Text,MAX_TEXT_LENGTH,"---^t^t^tAnzeige: %i Zeilen^t^t  ---",y);
		selfmessage(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"---^t^t^tZeilen: %i bis %i   ^t^t  ---",iLine,i-1);
		selfmessage(Text);
	}
	snprintf(Text,MAX_TEXT_LENGTH,"---^t^t^tvon insg. %i Zeilen^t^t  ---",fileline);
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

public look(a,User[]) {
	new j;
	new WONID;
	new iLine;
	new x=0;

	if (fileexists(Admincfg) == 1){
		iLine=filesize(Admincfg);
		new strMessage[MAX_DATA_LENGTH];
		for(j=1; j <= iLine; j++) {
			if (readfile(Admincfg, strMessage, j, MAX_DATA_LENGTH) != 0) {
				new strWONID[MAX_DATA_LENGTH];
				strbreak(strMessage, strWONID, strMessage, MAX_DATA_LENGTH);
				WONID = strtonum(strWONID);
				if (WONID == a){
					strcpy(Adminname,strMessage,MAX_DATA_LENGTH);
					x=1;
					break;
				}
			}
		}
		if(x==0){
			strcpy(Adminname,User,MAX_DATA_LENGTH);
		}
	} else {
		strcpy(Adminname,User,MAX_DATA_LENGTH);
		selfmessage("");
		selfmessage("Problem:");
		selfmessage("Kann admins.cfg nicht finden, daher gefakter Nickname moeglich!");
		selfmessage("");
		
	}
}

/*21.12.02: workaround von Blacky, um die korrekte Filegre zu ermitteln
realfilesize(fname[]){
	new sizeoffile;
	new sizeoffile2;
	new i;
	new string[MAX_DATA_LENGTH];

	sizeoffile=filesize(fname,1);
	sizeoffile2=sizeoffile;
	for(i=1; i<=sizeoffile2; i++) {
		readfile(fname,string,i,MAX_DATA_LENGTH);
		if(strlen(string)>98){
			sizeoffile-=1;
		}
		if(sizeoffile==i){
			break;
		}
	}
	return sizeoffile;
}*/

public plugin_init() {
	
	plugin_registerinfo("BAN-Plugin","Bans Player and stores Data in userban.cfg",STRING_VERSION);
	plugin_registercmd("admin_ban","sanction",ACCESS_BAN,"admin_ban <playername> <bantime> <reason>");
	plugin_registercmd("admin_bansearch","sanction",ACCESS_BAN,"admin_bansearch <playername or WONID>");
	plugin_registercmd("admin_banlist","sanction",ACCESS_BAN,"admin_banlist <linenumber>: toggle through your banlist");
	plugin_registercmd("admin_bandelete","sanction",ACCESS_BAN,"admin_bandelete <linenumber>");
	
	return PLUGIN_CONTINUE;
}