#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[] = "12.06.03";

new File[MAX_TEXT_LENGTH]="addons/adminmod/config/sdal_cvar_manager/commands.cfg";

#define MAX_CVARS	40
new g_CVarAccessLevel[MAX_CVARS][MAX_NUMBER_LENGTH];
new g_CVarShortCut[MAX_CVARS][MAX_NAME_LENGTH];
new g_CVar[MAX_CVARS][MAX_NAME_LENGTH];
new g_CVarValueRestrict[MAX_CVARS][MAX_NAME_LENGTH];
new g_realentries;

#define MAX_SENTENCE 9
new g_language;
new g_German[MAX_SENTENCE][MAX_TEXT_LENGTH]=	{{" '%s' steht zur Zeit auf '%s'. (Restriktion:%s)"},{" '%s' wurde auf '%s' gesetzt."},
						{" '%s' kann nur auf '%s' gesetzt werden."}, 
						{" Fehlender Rechtelevel fuer '%s'! (Benoetigtes Recht: %s)."},
						{" Fuer '%s' kann kein CVar-Eintrag gefunden werden!"},
						{" ERROR: commands.cfg wurde nicht gefunden."},
						{" Aendert CVars mit Kuerzeln (nur mit richtigem Rechtelevel)."},
						{" admin_cvar <cvar-kuerzel oder cvar> <value>: aendert cvar z.B. mp_timelimit etc."},
						{" admin_cvar_list: Liste aller Befehle, Kuerzel und dessen Rechtelevel"}};
new g_English[MAX_SENTENCE][MAX_TEXT_LENGTH]=	{{" '%s' is currently set to '%s'. (restriction:%s)"}, 
						{" '%s' was set to '%s'."},  
						{" '%s' can only be set to '%s'."},  
						{" Missing access-level for '%s'! (%s is needed)."},  
						{" No Cvar-entry found for'%s'."},  
						{" ERROR: No commands.cfg was found."},  
						{" Changing CVars with shortcuts (if you have a correct access-level)."},  
						{" admin_cvar <cvar-shortcut or cvar> <value>: changing cvar f.e. mp_timelimit etc."},  
						{" admin_cvar_list: list of accesslevel, shortcut and Cvar"}};

forward cvar_value_check(Value[],ID);
forward cvar_check_num(Str[]);
forward read_file();
forward selfmsg(Value1[],Value2[],Value3[],ID);
forward admin_cvar(HLCommand,HLData,HLUserName,UserIndex);
forward admin_cvar_list(HLCommand,HLData,HLUserName,UserIndex);

public plugin_init(){
	get_vaultnumdata("CVAR-MANAGER-LANGUAGE",g_language);  
	if(fileexists(File)){
		if( g_language==1 ){  
			plugin_registerinfo("CVar-MANAGER",g_German[6],STRING_VERSION);
			plugin_registercmd("admin_cvar","admin_cvar",ACCESS_VOTE_MAP,g_German[7]);
			plugin_registercmd("admin_cvar_list","admin_cvar_list",ACCESS_VOTE_MAP,g_German[8]);
		}else{
			plugin_registerinfo("CVar-MANAGER",g_English[6],STRING_VERSION);
			plugin_registercmd("admin_cvar","admin_cvar",ACCESS_VOTE_MAP,g_English[7]);
			plugin_registercmd("admin_cvar_list","admin_cvar_list",ACCESS_VOTE_MAP,g_English[8]);
		}
		read_file();
	}else{
		if( g_language==1 ){
			plugin_registerinfo("CVar-MANAGER",g_German[5],STRING_VERSION);
			selfmessage("[CVar-MANAGER] Konnte commands.cfg nicht finden!");
		}else{
			plugin_registerinfo("CVar-MANAGER",g_English[5],STRING_VERSION);
			selfmessage("[CVar-MANAGER] ERROR: No commands.cfg was found.");
		}
	}
	return PLUGIN_CONTINUE;
}

read_file(){
	new Data[MAX_DATA_LENGTH];
	new iFilesize;
	new i;
	iFilesize=filesize(File);
	for(i=0;i<=iFilesize;i++){
		readfile(File,Data,i,MAX_DATA_LENGTH);
		if(strlen(Data)!=0 && strncmp(Data,";",1)!=0 && strncmp(Data,"/",1)!=0 && strncmp(Data,"#",1)!=0){
			strsplit(Data,":",g_CVarAccessLevel[g_realentries],MAX_NUMBER_LENGTH,g_CVarShortCut[g_realentries],MAX_NAME_LENGTH,
				g_CVar[g_realentries],MAX_NAME_LENGTH,g_CVarValueRestrict[g_realentries],MAX_NAME_LENGTH);
			g_realentries ++;
			if(g_realentries==MAX_CVARS-1){
				break;
			}
		}
	}
	g_realentries --;
}

public admin_cvar(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Value[MAX_DATA_LENGTH];
	new dummy[1];	
	new iaccess;
	new i;
	new ok;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	
	if(strlen(Data)==0 || cvar_check_num(Data)==1){
		plugin_exec("admin_cvar_list",Data);
		return PLUGIN_HANDLED;
	}
	
	strbreak(Data,Data,Value,MAX_DATA_LENGTH);
	
	for(i=0;i<=g_realentries;i++){
		if(strcasecmp(g_CVarShortCut[i],Data)==0 || strcasecmp(g_CVar[i],Data)==0){
			if(strlen(Value)==0){
				getstrvar( g_CVar[i], Value, MAX_DATA_LENGTH );
				ok=0;
				selfmsg(g_CVar[i],Value,g_CVarValueRestrict[i],0);
				return PLUGIN_HANDLED;
				break;
			}else{
				iaccess = strtonum(g_CVarAccessLevel[i]);
				if(access(iaccess,User)==1){
					if(strlen(g_CVarValueRestrict[i])==0 || strcasecmp(g_CVarValueRestrict[i],"None")==0){
						setstrvar(g_CVar[i],Value);
						ok=1;
						selfmsg(g_CVar[i],Value,dummy,ok);
						break;
					}else{
						if(cvar_value_check(Value,i)==1){
							setstrvar(g_CVar[i],Value);
							ok=1;
							selfmsg(g_CVar[i],Value,dummy,ok);
							break;
						}else{
							ok=2;
							selfmsg(g_CVar[i],g_CVarValueRestrict[i],dummy,ok);
							break;
						}
					}
				}else{
					ok=3;
					selfmsg(g_CVar[i],g_CVarAccessLevel[i],dummy,ok);
					break;
				}
			}
		}
	}
	if (ok==0){
		ok=4;
		selfmsg(Data,dummy,dummy,ok);
	}
	return PLUGIN_HANDLED;
}

cvar_value_check(Value[],ID){
	new strA[MAX_NUMBER_LENGTH];
	new strB[MAX_NUMBER_LENGTH];
	new a;
	new b;
	new c;
	strsplit(g_CVarValueRestrict[ID],"-",strA,MAX_NUMBER_LENGTH,strB,MAX_NUMBER_LENGTH);
	
	if(cvar_check_num(Value)==1){
		a=strtonum(strA);
		b=strtonum(strB);
		c=strtonum(Value);
		if(b==0 || c>=a && c<=b){
			return 1;
		}
	}
	return 0;
}

cvar_check_num(Str[]){  
	new length = strlen(Str);  
	if (length > 0 ) {  
		if (Str[0] >= '0' && Str[0] <= '9' || Str[0] == '-') {  
			for ( new i = 1; i < length ; i++ ) {
				if (Str[i] < '0' || Str[i] > '9') {
					return 0; 
				}
			}
		} else { 
			return 0; 
		} 
	} else  {
		return 0;
	}
	return 1;  
}

selfmsg(Value1[],Value2[],Value3[],ID){
	new Text[MAX_TEXT_LENGTH];
	new Text1[MAX_TEXT_LENGTH];
	if(g_language==1){
		snprintf(Text1,MAX_TEXT_LENGTH,g_German[ID],Value1,Value2,Value3);
	}else{
		snprintf(Text1,MAX_TEXT_LENGTH,g_English[ID],Value1,Value2,Value3);
	}
	snprintf(Text,MAX_TEXT_LENGTH,"[CVAR-MANAGER] %s",Text1);
	selfmessage(Text);
}

public admin_cvar_list(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new i;
	new iLine;
	new imaxLine;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iLine=strtonum(Data);
	if(iLine==0){
		iLine=0;
	}
	if(iLine>g_realentries){
		iLine=0;
	}
	imaxLine = iLine+9;
	if(imaxLine>g_realentries){
		imaxLine=g_realentries;
	}
	selfmessage("----------------------------------- [CVar-MANAGER] ----------------------------------");
	selfmessage("^t^t^t^t^t*Access*^t^t^t^t^t^t*Shortcut*^t^t^t^t*Restricted Values*^t^t^t^t^t^t*CVar*");
	for(i=iLine;i<=imaxLine;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"%i.^t^t^t^t%s^t^t^t^t^t^t^t^t^t %s ^t^t^t^t^t^t^t^t^t^t^t %s^t^t^t^t^t^t^t^t^t^t^t^t^t^t^t %s",i,g_CVarAccessLevel[i],g_CVarShortCut[i],g_CVarValueRestrict[i],g_CVar[i]);
		selfmessage(Text);
	}
	selfmessage( "--------------------------------------------------------------------------------------------");
	snprintf(Text,MAX_TEXT_LENGTH,"---                     ^t^t^tAnzeige: %i bis %i   ^t^t           ---",iLine,imaxLine);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"---                     ^t^t^tvon insg. %i CVars^t^t  	           ---",g_realentries);
	selfmessage(Text);
	return PLUGIN_HANDLED;
}



